<?php
/*------------------------------------------------------------------------
 # mod_leocontentcarousel - Leo ContentCarousel Module
 # ------------------------------------------------------------------------
 # author    LeoTheme
 # copyright Copyright (C) 2011 leotheme.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Websites: http://www.leotheme.com
 # Technical Support:  Forum - http://www.leotheme.com/forum.html
-------------------------------------------------------------------------*/
// no direct access
defined('_JEXEC') or die;
// Include the syndicate functions only once
require_once dirname(__FILE__).DS.'helper.php';
$list = modLeoContentCarouselHelper::processFunction( $params, $module->module );
//echo "<pre>";print_r($list);die;
if( !empty($list) ):
	// split pages following the max items display on each page.
	$maxItemsPerCols = (int)$params->get( 'max_items_per_cols', 3 );
	$maxPages = (int)$params->get( 'max_items_per_page', 3 );
	$pages = array_chunk( $list, $maxPages  );
	$totalPages = count($pages);
	// calculate width of each row.
	//$itemWidth = 100/$maxItemsPerCols -0.1;
	$source =  $params->get( 'data_source', 'content' );
	$tmp = $params->get( 'module_height', 'auto' );
	$moduleHeight   =  ( $tmp=='auto' ) ? 'auto' : (int)$tmp.'px';
	$tmp = $params->get( 'module_width', 'auto' );
	$moduleWidth    =  ( $tmp=='auto') ? 'auto': (int)$tmp.'px';
	$openTarget 	= $params->get( 'open_target', '_parent' ); 
	$thumbWidth    = (int)$params->get( 'thumbnail_width', 180 );
	$thumbHeight   = (int)$params->get( 'thumbnail_height', 60 );
	$thumbnailAlignment = $params->get( 'thumbnail_alignment', '' );	
	$displayButton	= $params->get( 'display_button', 1 );
	$itemLayout 	= 'sliding-image';
	$theme		    =  $params->get( 'theme', '' ); 
	$showReadmore	= $params->get( 'show_readmore', 1 );
	$showSubTitle 		= $params->get( 'show_sub_title', '1' );
    $showMainTitle 		= $params->get( 'show_main_title', '1' );
    $showSubDesc 		= $params->get( 'show_sub_desc', '1' );
	$showImage 		= $params->get( 'show_image', 1 );
	$sliderSpeed 		= $params->get( 'sliderspeed', 500 );
	$itemSpeed 		= $params->get( 'itemspeed', 500 );
	$effect 		= $params->get( 'effect', 'easeOutExpo' );
	$numscroll 		= $params->get( 'numscroll', 1 );
	$mainBg 		= $params->get( 'main_bg', 'B0CCC6' );
	$itemBd 		= $params->get( 'item_bd', '808040' );
	$itemBg 		= $params->get( 'item_bg', 'FF7766' );
	$itemHits 		= $params->get( 'itemHits', 1 );
	$itemDateCreated 		= $params->get( 'itemDateCreated', 1 );
	$itemComments 		= $params->get( 'itemComments', 1 );
	$linkImage 		= $params->get( 'linkImage', 1 );
	$linkSubtitle 		= $params->get( 'linkSubtitle', 1 );
	$mousewheel 		= $params->get( 'mousewheel', 1 );
    $itemWidth 	    = (100/$maxItemsPerCols)  . "%;";
    $display = 'block';
    if($displayButton==1){
        $display = 'block';
    }else{
        $display = 'none';
    }
	modLeoContentCarouselHelper::loadMediaFiles( $params, $module, $theme );
    /*Add Custom CSS*/
    $leodocs = JFactory::getDocument();
    $leodocs->addStyleDeclaration(
        '.leo-content-wrapper{background:#'.$mainBg.';height:'.($moduleHeight).';
        }
        .leo-image{border:4px #'.$itemBd.' solid;
        }
        .leo-item-carousel:hover{background:#'.$itemBg.';
        }
        .leo-nav{display:'.$display.';
        }
        '					   
    );
    
    
	$itemLayoutPath = modLeoContentCarouselHelper::getItemLayoutPath($module->module, $theme, $itemLayout  );
	$style = 'style="height:'.$params->get('item_height','auto');
	if( $params->get('hover_effect',0) ){
		$style .= ';background-color:#'.$params->get('mouseout_bg','F0F0F0');
	}
	$style .='"';
	if( !empty($theme) ){
		$layout = trim($theme).DS.'default';
		require( JModuleHelper::getLayoutPath($module->module, $layout ) );
	} else {
		require( JModuleHelper::getLayoutPath($module->module) );
	}
	
	?>
	<script type="text/javascript">
		$('#leo-container-carousel-<?php echo $module->id;?>').contentcarousel({
            moduleId        : '<?php echo $module->id;?>',
            numCols         : <?php echo $maxItemsPerCols;?>,
        	// speed for the sliding animation
        	sliderSpeed		: <?php echo $sliderSpeed;?>,
        	// easing for the sliding animation
        	sliderEasing	: '<?php echo $effect;?>',
        	// speed for the item animation (open / close)
        	itemSpeed		: <?php echo $itemSpeed;?>,
        	// easing for the item animation (open / close)
        	itemEasing		: '<?php echo $effect;?>',
        	// number of items to scroll at a time
        	scroll			: <?php echo $numscroll;?>
        });
	</script>
<?php endif; ?>

